var listener_cometd = null;
var listener_cometd_sonar = null;
var pushClientId = 0;
var msgPushAffirmTimers = {};
var reconnectTime = 0;
var lastConnectStatus = true;
var handshake_num = 0;
var debug = false;
var verson='1.0';
function print_msg(msg)
{
	if(debug)
	{
		console.log("[DOLPHIN CONNECT]: "+msg);
	}
}

var channel = {
	push: "/service/dolphin/tabpush",
	device: "/service/dolphin/device",
	tab : "/service/dolphin/sync/tab",
	bookmark: "/service/dolphin/sync/desktop",	
	sonar:"/service/dolphin/sonar"
};

var INJECT_STATUS={
		OFFLINE_SENT:"0",
		ALREADY_SENT:"1",
		SEND_FAIL:"2",
		ARRIVE_FAIL:"3",
		SENDING:"4",
		LOGIN:"5",
};

var Subscribtion = {
	tab:null,
	bookmark:null,
	push:null,
	device:null,
	sonar:null,
	connect:null
};

var Handler = {
	tab:tab_receive,
	bookmark:bookmark_receive,
	push:receive,
	device: receive,
	sonar:receive_sonar
};

self.port.on("message", function(msg){
    var category = msg.category;
    var type = msg.type;
    var data = msg.data;
    if(category == 'push') {
        switch(type) {
           case "connect":
				print_msg("contentscript receive [connect] request from core.");
				connect(data);
				break;
           case "disconnect":
				print_msg("contentscript receive [disconnect] request from core.");	
				if(data) {
					disconnect({clientId:data.clientId});
				}
				else {
					disconnect();
				}
               break;
           case "push":
				print_msg("contentscript receive [push] request from core.");
				send(data, channel.push, msg.extInfo); 
				break;
           case "device":
				print_msg("contentscript receive [device] request from core.");
				send(data, channel.device);
				break;
           case 'subscribe':
				print_msg("contentscript receive [subscript] request from core.");
				subscribe(data);
				break;
           case 'unSubscribe':
				print_msg("contentscript receive [unSubscript] request from core.");
				unSubscribe(data);
				break;
        }   
    }
    else if (category == 'sonar') {
        switch(type) {
           case "connect":
               connect_sonar(data);
               break;
           case "disconnect":
               disconnect_sonar();
               break;
        }
    }
});

/*
 * Params:
 * 		-config example:['tab', 'bookmark']
 */
function subscribe (config) {
	for(var id in config) {
		//Subscribtion[config[id]] = listener_cometd.subscribe(channel[config[id]], Handler[config[id]]);
		if(Subscribtion[config[id]] == null) {
			try {
				Subscribtion[config[id]] = listener_cometd.addListener(channel[config[id]], Handler[config[id]]);				
			}
			catch(e) {
				////console.log("subscribe exception");
				//console.log(e.message);
			}
		}
		//console.log("subscribe:" + config[id]);
	}
}

/*
 * Params:
 * 		-config, ['tab', 'bookmark']
 */
function unSubscribe (config) {
	for(var id in config) {
		if(Subscribtion[config[id]] != null) {
			//listener_cometd.unsubscribe(Subscribtion[config[id]]);
			try {
				listener_cometd.removeListener(Subscribtion[config[id]]);				
			}
			catch(e) {
				//console.log("unSubscribe exception");
				//console.log(e.message);
			}
			Subscribtion[config[id]] = null;
			//console.log("unSubsribe:" + id);
		}	
	}
}

function send(data, _channel, extInfo) {
	//console.log(JSON.stringify(data));
	try {
	    listener_cometd.publish(_channel, data, function(message){
			if(_channel != channel.push)
			{
				return;
			}
			
			if(message.successful)
			{
				print_msg("push message reply from server.");
				//infor user message has already sent
				//start timer to listen partern feedback.
				if(msgPushAffirmTimers[message.id])
				{
					clearTimeout(msgPushAffirmTimers[message.id]['timeoutId']);
					delete msgPushAffirmTimers[message.id];
				}	
	
				print_msg("install push message [receive feedback] timer");
				msgPushAffirmTimers[message.id] = {'timeoutId':setTimeout(function(){
					//inform user message sent failed.
					//data=JSON.parse(pushData);
					
					//TODO:
					////////////////////////////
					//PushRespInjectBox(extInfo.type, extInfo.subtype, INJECT_STATUS['ARRIVE_FAIL']);
					///////////////////////////
					print_msg("push message [receive feedback] timeout and notify core.");
					self.postMessage({category:'push', type:'inject', data:{status:INJECT_STATUS['ARRIVE_FAIL'], type:extInfo.type, subtype:extInfo.subtype}});
					
				},10000)};
				//inform has sent
				
				////////////////////////
				//PushRespInjectBox(extInfo.type, extInfo.subtype, INJECT_STATUS['ALREADY_SENT']);
				///////////////////////
				print_msg("send push sucessful inject request to core");
				self.postMessage({category:'push', type:'inject', data:{status:INJECT_STATUS['ALREADY_SENT'], type:extInfo.type, subtype:extInfo.subtype}});
			}
			else
			{
				//inform user message sent fail.
				//data=JSON.parse(pushData);
				
				//TODO:
				/////////////////////
				//PushRespInjectBox(extInfo.type, extInfo.subtype, INJECT_STATUS['SEND_FAIL']);
				////////////////////
				print_msg("send push fail inject request to core");
				self.postMessage({category:'push', type:'inject', data:{status:INJECT_STATUS['SEND_FAIL'], type:extInfo.type, subtype:extInfo.subtype}});
				//this connection may broken, so, reconnect
				
			}
		});		
	}
	catch(e) {
		//console.log("send exception");
		//console.log(e.message);
		print_msg("send push re_auth request to core");
		self.postMessage({category:'push', type:'re_auth', data:''});
	}
}

//send message to pageworker listener.
function receive(message) {
	if(message.data.type=='received')
	{
		print_msg("receive [received] message from server.");
		//TODO: affirm process. receive this message stands for partener device receive push message, otherwise wait for timeout.
		if(msgPushAffirmTimers[message.data.msg_id])
		{
			clearTimeout(msgPushAffirmTimers[message.data.msg_id]['timeoutId']);
			delete msgPushAffirmTimers[message.data.msg_id];
		}
	}
	else
	{
		print_msg("receive [push] message from server.");
		self.postMessage({category:'push', type:'recv', data:message});	
	}
}

function receive_sonar(message) {
    self.postMessage({category:'sonar', type:'recv', data:message});
}

function tab_receive(message) {
	self.postMessage({category:'push', type:'tab', data:message});
}

function bookmark_receive(message) {
	self.postMessage({category:'push', type:'bookmark', data:message});
}

/*
 * config example: 
 *     {dev_id:'xxxxx'}
 */
function connect(config){
	print_msg("[6][Push] start push connect...");			
	debug = config.debug;
    //vesion=config.version;
	listener_cometd = new jQuery.Cometd();
    listener_cometd.configure({
        url: config.url,
        logLevel: 'warn',
		maxNetworkDelay: 5000
    });
    
    var handshakeListener = null;
	print_msg("[7][Push] start push handshake...");	
	handshake_num  = 0;
    handshakeListener = listener_cometd.addListener('/meta/handshake', function(message) {
    	print_msg("[8][Push] push handshake has response...");	
        if(message.successful)
        {
        	print_msg("[9][Push] push handshake success...");	
			pushClientId = message.clientId;  
            Subscribtion.device = listener_cometd.addListener(channel.device,Handler.device);
			
            print_msg("[10][Push] push start join...");	
            listener_cometd.publish(channel.device, {
                type : "join",
                device_id : config.dev_id,    
                sync_channels : config.sync_channels
            });
			
            listener_cometd.removeListener(handshakeListener);
            
			Subscribtion.connect = listener_cometd.addListener('/meta/connect', function(message){
					if(message.successful) {
						
						//Reference:[http://cometd.org/documentation/cometd-java/server/multipleclients]
						if(message.advice && message.advice['multiple-clients'] && message.advice['multiple-clients'] == true) {
							//fetch previous pushClientId and disconnect it.
							
							//if(localStorage['DolphinBrowserPushClientid'] != null) {
								//self.disconnect({"clientId":localStorage['DolphinBrowserPushClientid']});
								//self.login();	
							//}
							self.postMessage({category:'push', type:'multiple-clients'});
						}
						else{
							var _connectStatus = true;
							self.postMessage({category:'push', type:'connect', data:{status:_connectStatus, clientId: pushClientId}});						
						}
						
						if(lastConnectStatus==false)
						{
							//Before reconnect success, other device may send message to this device.So, need check message and call get_msg API.
							//TODO:
							try {
								listener_cometd.publish(channel.device, {
									type : "join",
									device_id : config.dev_id,    
									sync_channels : config.sync_channels
								});
							}
							catch (e) {
								print_msg(e);
							}
						}
						lastConnectStatus = true;						
						
					}
					else {
						var _connectStatus = false;
						self.postMessage({category:'push', type:'connect', data:{status:_connectStatus}});
						
						lastConnectStatus=false;
						//if 5min can not connect success.
						if(message.advice.reconnect=='retry') {
							//Server address may changed, auth again.
							reconnectTime += message.advice.interval;
							if(message.advice.interval >= 300000) {	
								self.postMessage({category:'push', type:'re_auth', data:''});						
							}
						}
						else {
							self.postMessage({category:'push', type:'re_auth', data:''});
						}
					}
				});
            
        }
        else {
			//should restart handshake process?
			//listener_cometd.handshake();
			 print_msg("[10][Push] handshake failed."+JSON.stringify(message));	
			handshake_num++;
			if(handshake_num > 10)
			{
				handshake_num = 0;
				self.postMessage({category:'push', type:'re_auth', data:''});				
			}
        }    	
    });
    listener_cometd.handshake({
		ext:{
			token: config.token,
			deviceid: config.dev_id, 
			ext:config.ext,
			version:config.version
		}
	});
}

function disconnect(param){
    
	unSubscribe(['tab', 'bookmark', 'push', 'device', 'connect']);
    if(listener_cometd)
    {
    	try{
			if(param) {
				listener_cometd.disconnect(param);					
			}
			else {
				listener_cometd.disconnect();					
			}
    	}
    	catch(e) {
    		print_msg(e.message);
    	}
        delete listener_cometd;
        listener_cometd = null;
    }
}

function connect_sonar(config) {
    listener_cometd_sonar = new jQuery.Cometd();

    var handshakeListener =  null;
    var subscribeListener = null;

    listener_cometd_sonar.configure({
        url: config.url,
        logLevel:'warn'
    });
    
    handshakeListener = listener_cometd_sonar.addListener('/meta/handshake', function (message) {
        //console.log("receive handshake message.");
        if(message.successful)
        {
            //console.log("handshake successful.");
            Subscribtion.sonar = listener_cometd_sonar.addListener(channel.sonar, receive_sonar);
            listener_cometd_sonar.publish(channel.sonar, {
                type : "note",
                device_id : config.dev_id    
            });
            listener_cometd_sonar.removeListener(handshakeListener);
        }
    });
    
    listener_cometd_sonar.handshake();
}

function disconnect_sonar(){
	listener_cometd_sonar.removeListener(Subscribtion.sonar);
    if(listener_cometd_sonar)
    {
        listener_cometd_sonar.disconnect();
        delete listener_cometd_sonar;
        listener_cometd_sonar = null;
    }
}
