////////////////////////////////////////////////////////////////////////////////
//
//  Adaptor to communcate with main module. Written by BaidengTian
//
///////////////////////////////////////////////////////////////////////////////
self.port.on("message", function(msg){
    var type = msg.type;
    var data = msg.data;
    //console.log(JSON.stringify(msg));
    try {
    	onMessageHandler[type](data);    
    }
    catch(e) {
    	//console.log(e);
    }
});

var demo = null;

function load(msg){
    //console.log("load init.");
    CommInterface.CommInfo.nick_name = msg.nick_name;
    CommInterface.CommInfo.user_name = msg.user_name;
    CommInterface.CommInfo.email = msg.email;
    CommInterface.CommInfo.token = msg.token;
    CommInterface.CommInfo.login_typeName = msg.login_typeName;
    CommInterface.CommInfo.device_list = msg.device_list;
    CommInterface.CommInfo.get_device_shortcut = function(){return msg.device_shortcut;};
    CommInterface.CommInfo.get_setting = function(){return msg.setting;};
    CommInterface.CommInfo.tab_sync_list_sorted = function(){return msg.tab_sync_list_sorted;};
    CommInterface.get_devicename = function(){return msg.devicename;};
    CommInterface.pusher.isConnect = function(){ return msg.is_connect;};
    CommInterface.get_favico = function(url) {
    	var icon_url = msg.favicons[url];
    	if (icon_url == null) {
    		icon_url = "chrome://mozapps/skin/places/defaultFavicon.png";  
    	}
    	////console.log("Favicon:"+icon_url);
    	return icon_url;
    };
	CommInterface.GetPushDevicesSorted = function(){
		return msg.device_list;
	}
    demo = new SyncFontEnd();
}

var chrome  = {
    extension:{
        getBackgroundPage: function(){
            return CommInterface;                             
        }           
    },
    tabs:{
    	query: function(cond,callback) {
    		onMessageHandler.current_tab = callback;
    		self.port.emit("message", {type:'current_tab'});
    	}	
    },
    windows:{
    	WINDOW_ID_CURRENT:0
    }
};

var onMessageHandler = {
    load:load,  
	updateConnect:function(connectStatus) {
		CommInterface.pusher.isConnect = function(){ return connectStatus;};
	},	
    sonar_fail:null,
    sonar_success:null,
    dolphin_shade:null,
    dolphin_fail:null,
    current_tab: null,
    reflashPage: reflashPage,
    shortCutInit: shortCutInit,
    refresh_name: function(name) {
    	if(demo) {
    		demo.reflashDeviceName(name);
    	}
    }
};

function shortCutInit(info) {
	if(info.device_shortcut) {
		CommInterface.CommInfo.get_device_shortcut = function() { return info.device_shortcut; };
	}
	
	if(info.device_list) {
		CommInterface.CommInfo.device_list = info.device_list;
	}
	if(demo){
		demo.shortCutInit();	
	}
}

function reflashPage(info){
	//console.log("receive reflashPage message."+info.type);
	if(info.type == 'push') {
		CommInterface.CommInfo.get_device_shortcut = function(){ return info.shortcut; };
		CommInterface.CommInfo.device_list = info.devices;
		CommInterface.GetPushDevicesSorted = function(){
			return info.devices;
		}
		CommInterface.pusher.isConnect = function(){ return info.connectStatus;};
	}
	else if(info.type == 'sync'){
		CommInterface.CommInfo.tab_sync_list_sorted = function() { return info.devices; };
		////console.log(JSON.stringify(info.devices));
	}
	if(demo) {
		demo.reflashPage(info.devices, info.shortcut, info.type);
	}
}

function win_close(){
         self.port.emit("message", {type:'hide'});
}

var CommInterface = {
    CommInfo:{
        nick_name:'',
        user_name:'',
        login_typeName:'',
        device_list:[],
        get_device_shortcut:null,
        get_setting:null,
        tab_sync_list_sorted:null,
        save_device_shortcut: function(data){
            self.port.emit("message",{type:'save_dev_shortcut',msg:data});
        },
        save_setting: function(data){
            self.port.emit("message",{type:'save_setting',msg:data});
        }
    },
    track_event: function(config) {
    		//console.log("tack>>>>");
	    	self.port.emit("message", {type: "ga" , msg: config});
	},  
    sonar_close: function(){
        self.port.emit("message",{type:"sonar_close"});     
    },
    thirdParty_login: function(tmpId,win){
        self.port.emit("message",{type:"thirdParty_login",msg:tmpId});              
    },
    dolphin_login_cancel: function() {
    	self.port.emit("message",{type:"dolphin_login_cancel",msg:''});
    },
    get_sonar_cmd: function(success,fail,a,type){
    	//console.log("here is get sonar cmd");
        onMessageHandler.sonar_fail = fail;
        onMessageHandler.sonar_success = function(data){
        	if(data.length > 1 && data[1] != null) {
        		success(data[0], data[1]);
        	}
        	else {
        		success(data[0]);
        	}
        };
        self.port.emit("message", {type:"get_sonar_cmd",msg:type});        
    },
    dolphin_login: function(username, passwd, shade, fail, win){
        onMessageHandler.dolphin_shade = shade;
        onMessageHandler.dolphin_fail = fail;
        self.port.emit("message", {type:"dolphin_login", msg:{username:username, password:passwd}});       
    }, 
    get_favico: function(){
          return "chrome://mozapps/skin/places/defaultFavicon.png";  
    },
    pusher:{
        isConnect:null   
    },  
    open_userinfo_page: function(){
        self.port.emit("message",{type:"open_userinfo_page"});                    
    },
    pushSend:function(id,callback){
        self.port.emit("message",{type:"pushSend", msg:id}); 
    },
    get_devicename:null, 
    dev_rename: function(dev_id, name, type) {
    	self.port.emit("message",{type:"devRename", msg:{dev_id:dev_id, name: name, type: type}}); 
    },
    logout: function() {
    	self.port.emit("message",{type:"logout"}); 
    },
	pushReConnect: function(flag){
		self.port.emit("message", {type:"reConnect", msg:flag});
	},
	GetPushDevicesSorted: function(){return [];}
}
