exports.BookmarkSyncCtrl = function(){return BookmarkSyncCtrl;};
exports.BookmarkSync = sync;
exports.BookmarkInfo = function(){return BookmarkInfo;};

var BookmarkSyncStorage = require("./storage").BookmarkSyncStorage();
var timers = require("sdk/timers");
var SYNC_state = require("./api2").SYNC_state;
var localStorage = require("sdk/simple-storage").storage;
var CommInfo = require("../common").CommInfo();

var AddBookmarkListener = require("./monitor").AddBookmarkListener;
var addBookmarkObserver = require("./bookmarkAdaptor").addBookmarkObserver;
var print_msg = require("../util").print_msg;
var get_utc = require("../util").get_utc; 
var track_err = require('../util').track_error; 
var BookmarkInfo = {};

/*
var BookmarkInfo = {
	deletes:[],
	updates:[],
	latest_sid:0,
	finish:1,
	treeRoot:null,
	local:null,
	ongoing:0
};
*/

BookmarkInfo.deletes=[];
BookmarkInfo.updates=[];
BookmarkInfo.latest_sid=0;
BookmarkInfo.finish=1;
BookmarkInfo.treeRoot=null;
BookmarkInfo.local = null;
BookmarkInfo.ongoing = 0;
BookmarkInfo.lastSyncTime = 0;
print_msg('[control] bookmark sync init!!!!')

var BookmarkSyncCtrl = {
	timeIntervalId:null	
};

BookmarkSyncCtrl.sync = sync; 

function sync(sid) {
	//console.log('bookmark sync Start...');
	try{
		if(sid != null) {
			var sid_local = CommInfo.after_sid();
			if(sid_local.bookmark >= sid) {
				//console.log("local is greater than push sid.");
				return;
			}	
		}
			
		//Check last sync time, because sync may have been interrupted when something error happen.
		//If the time inverval exceeds the threshold(Now, it is 1 min), reset the ongoing flag, and sync can go on,
		//otherwise, you have no choice but to reboot browser.
		if(BookmarkInfo.ongoing == 1){
			if((get_utc()/1000 - BookmarkInfo.lastSyncTime) > 60)
			{
				BookmarkInfo.ongoing == 0;
				print_msg('[control] force quite!!!');
			}
			
		}
		
		if(BookmarkInfo.ongoing == 0) {
			print_msg('[control] start sync!!!!')
			var setting = CommInfo.get_setting();
			if(setting.bookmark) {
				BookmarkInfo.ongoing = 1;
				var time_current = get_utc()/1000;
				BookmarkInfo.lastSyncTime = time_current;
				
				if(localStorage['DolphinBrowserBookmark'] == null) {
					BookmarkSyncStorage.init(BookmarkSyncStorage.syncLocalPreprocess, SYNC_state);
				}
				else
				{
					BookmarkSyncStorage.syncLocalPreprocess(SYNC_state);
				}	
			}
		}
	}catch(err){
		print_msg(err);
		track_err(err);
		if(BookmarkInfo && BookmarkInfo.ongoing){
			BookmarkInfo.ongoing = 0;
		}
	}
};

BookmarkSyncCtrl.init = function() {
	AddBookmarkListener();
	addBookmarkObserver();
}

