exports.thirdPartyLoginWinFocus = thirdPartyLoginWinFocus;
exports.thirdParty_login = thirdParty_login;
exports.dolphin_login = dolphin_login;
exports.open_userinfo_page = open_userinfo_page;
exports.logout = logout;
exports.logout_clear = logout_clear;
exports.check_login_status = check_login_status;
exports.login_init = login_init;
exports.dolphin_login_cancel = dolphin_login_cancel;
exports.save_user_login_info = save_user_login_info;
exports.get_user_info = get_user_info

var util = require("../util");
var ThirdParty = require("../common").ThirdParty();
var API = require("../const").API(); 
var CommInfo = require("../common").CommInfo();
var jQuery = util.jQuery();
var localStorage = require("sdk/simple-storage").storage;
var push_mod = require("../push/push");
var push_init = push_mod.push_init;
var push_close =  push_mod.push_close;
var removeall_menu = require("../menu").removeall_menu;
var sync_control = require("../tab/tabsync").sync_control;
var BookmarkSyncCtrl = require("../bookmarks/control").BookmarkSyncCtrl();
var tabs_sync_clear = require("../tab/tabsync").tabs_sync_clear;
var destory_mainWin = require("../main").destory_mainWin;
//var INJECT_CODE = require("../common").INJECT_CODE();
var timers = require("sdk/timers");
var setTimeout = timers.setTimeout;

var track_event = require("../track").track_event;
var extLocale  = require("../string").extLocale();

var setBelugaCode = require("../track").setBelugaCode;
var API_validate_token = require("../tab/api").API_validate_token;
var baTrackClose = require("../track").baTrackClose;
var print_msg = require("../util").print_msg;
var GEN_INJECT_SCRIPT = require("../common").GEN_INJECT_SCRIPT;
var INJECT_STATUS = require("../common").INJECT_STATUS();
/*
	Handler for login window shading.
*/
var dolphin_login_shade_handler;

/*
	Handler for login error.
*/
var dolphin_login_error_handler;

/*
	Handler for login window close.
*/
var dolphin_loginwin_close;

/*
	Object of third party login window.
*/
var thirdPartyLoginWin;

var tmp_user_name;
var tmp_password;
var timer_id = null;
var timer_start = 0;
var main_handler = null;
var dolphin_xhr = null;

/*
	Third party login entry.This function will create a new popup window and load 
	third-party auth page, login result will be checked by tab update listener.
	
	Params:
		type: one of ['facebook','google']
*/
//function thirdParty_login(type, win)
function thirdParty_login(type, handler)
{
    main_handler = handler;
	var tabs = require("sdk/tabs");
	if(thirdPartyLoginWin != null)
	{
		thirdPartyLoginWin.activate();
		return;
	}
    var url =  API.signup + ThirdParty[type]+"?r=US&cid=" + util.get_clientid(false) +"&display=page&v=2&t=" + util.get_os_type()+"24";		
	tabs.open({
		url:url,
		onOpen:function onOpen(tab)
		{
			thirdPartyLoginWin=tab;
			main_handler.popupHidden();	
		},
		onClose:function onClose(tab)
		{
			thirdPartyLoginWin=null;
			main_handler.popupShow(); 
		},
		onReady:function onReady(tab)
		{
			var changeInfo={};		
			changeInfo.url=tab.url;
			if( changeInfo.url && changeInfo.url !=  "" && 
							(changeInfo.url.substr(0, API.loginresult[0].length) == API.loginresult[0] ||
							 changeInfo.url.substr(0, API.loginresult[1].length) == API.loginresult[1]))
			{
				require("sdk/timers").clearInterval(timer_id);
				var ret_url = changeInfo.url;
				var ret_st = util.getQueryStringRegExp(ret_url,"status");
				if(ret_st == '0')
				{
					require("sdk/timers").clearInterval(timer_id);
					CommInfo.token = util.getQueryStringRegExp(ret_url,"token");
					CommInfo.email = util.getQueryStringRegExp(ret_url,"email");
					CommInfo.user_name = util.getQueryStringRegExp(ret_url,"user_name");
					CommInfo.nick_name = util.getQueryStringRegExp(ret_url,"nick_name");
					CommInfo.login_type = util.getQueryStringRegExp(ret_url,"type");
					CommInfo.region_domain = null;
					CommInfo.region_domain = util.getQueryStringRegExp(ret_url,"region_domain");
					CommInfo.push_domain = null;
					CommInfo.push_domain = util.getQueryStringRegExp(ret_url,"push_domain");
							
					if(CommInfo.login_type == '10')
					{
							CommInfo.login_typeName = 'Google';
					}
					else if(CommInfo.login_type == '11')
					{
							CommInfo.login_typeName = 'Facebook';			
					}
					else if(CommInfo.login_type == '1') {
						CommInfo.login_typeName = extLocale['Sinaweibo'];	
					}
					else if(CommInfo.login_type == '4') {
						CommInfo.login_typeName = extLocale['TencentQQ'];	
					}
					print_msg("login successful.");
					print_msg(CommInfo.token, CommInfo.user_name, CommInfo.login_type);        
					
					//get_user_info();
					if (CommInfo.nick_name == null || CommInfo.nick_name == '') {
						CommInfo.nick_name = CommInfo.email;
					}
					CommInfo.is_login = true;
					//require("sdk/timers").clearInterval(timer_id);
					login_init(true);
					thirdPartyLoginWin.close();
					//thirdPartyLoginWin = null;
					//main_handler.popupShow(); 
					
					track_event({
						category:'general',
						action:'login',
						label:CommInfo.login_typeName+"[success]",
						value:1
					});	
				}
				else{
					CommInfo.is_login = false;
					//require("sdk/timers").clearInterval(timer_id);
					//thirdPartyLoginWin.close();
					//thirdPartyLoginWin = null;
					main_handler.popupShow();  
					
					track_event({
						category:'general',
						action:'login',
						label:CommInfo.login_typeName+"[fail]",
						value:1
					});	
				}
			}		
		}
	});	
	 
	 return;
	 //following code ignore
     let { open } = require('sdk/window/utils');
     var win_close = login_closed(thirdPartyLoginWin);
     if(thirdPartyLoginWin == null || win_close )
     {
 		thirdPartyLoginWin = open(null, {
             name: 'dolphin connect',
             features: {
                 width:997,
                 height:595,
                 centerscreen: true,
             }
        });
		thirdPartyLoginWin.location.href= url;	 
        main_handler.popupHidden();
        timer_start = util.get_utc(); 
        timer_id = require("sdk/timers").setInterval(check_login_result,1000);
     }       
     //sonar_close();
}

function login_closed(win){
    try{
        var ret = win.closed;
        return ret;
    }
    catch(e){
        //print_msg(e.message);
        return true;
    }
}

function check_login_result(){
        var timer_now = util.get_utc();
        print_msg("check location.");
        var win_close = login_closed(thirdPartyLoginWin);
        if((timer_now -timer_start)> 60*5*1000 || win_close) {
             require("sdk/timers").clearInterval(timer_id);
             
             if(!win_close)
             {
                 thirdPartyLoginWin.close();
             }
             
             CommInfo.is_login = false;
             thirdPartyLoginWin = null;
             main_handler.popupShow();
             main_handler = null;
             return;
        } 

        var changeInfo={};
        print_msg(thirdPartyLoginWin.location.href);
        changeInfo.url = thirdPartyLoginWin.location.href;
        if( changeInfo.url && changeInfo.url !=  "" && 
                        (changeInfo.url.substr(0, API.loginresult[0].length) == API.loginresult[0] ||
                         changeInfo.url.substr(0, API.loginresult[1].length) == API.loginresult[1]))
        {
        		require("sdk/timers").clearInterval(timer_id);
                var ret_url = changeInfo.url;
                var ret_st = util.getQueryStringRegExp(ret_url,"status");
                if(ret_st == '0')
                {
            		require("sdk/timers").clearInterval(timer_id);
        			CommInfo.token = util.getQueryStringRegExp(ret_url,"token");
        			CommInfo.email = util.getQueryStringRegExp(ret_url,"email");
        			CommInfo.user_name = util.getQueryStringRegExp(ret_url,"user_name");
        			CommInfo.nick_name = util.getQueryStringRegExp(ret_url,"nick_name");
        			CommInfo.login_type = util.getQueryStringRegExp(ret_url,"type");
		 			CommInfo.region_domain = null;
					CommInfo.region_domain = util.getQueryStringRegExp(ret_url,"region_domain");
					CommInfo.push_domain = null;
					CommInfo.push_domain = util.getQueryStringRegExp(ret_url,"push_domain");
			       			
                    if(CommInfo.login_type == '10')
                    {
                            CommInfo.login_typeName = 'Google';
                    }
                    else if(CommInfo.login_type == '11')
                    {
                            CommInfo.login_typeName = 'Facebook';			
                    }
                    else if(CommInfo.login_type == '1') {
                    	CommInfo.login_typeName = extLocale['Sinaweibo'];	
                    }
                    else if(CommInfo.login_type == '4') {
                    	CommInfo.login_typeName = extLocale['TencentQQ'];	
                    }
                    print_msg("login successful.");
                    print_msg(CommInfo.token, CommInfo.user_name, CommInfo.login_type);        
                    
        			//get_user_info();
        			if (CommInfo.nick_name == null || CommInfo.nick_name == '') {
        				CommInfo.nick_name = CommInfo.email;
        			}
                    CommInfo.is_login = true;
	    			require("sdk/timers").clearInterval(timer_id);
	                thirdPartyLoginWin.close();
	                thirdPartyLoginWin = null;
	                main_handler.popupShow(); 
	                login_init(true);
	                
        			track_event({
						category:'general',
						action:'login',
						label:CommInfo.login_typeName+"[success]",
						value:1
					});	
                }
                else{
                	CommInfo.is_login = false;
                    require("sdk/timers").clearInterval(timer_id);
                    thirdPartyLoginWin.close();
                    thirdPartyLoginWin = null;
                    main_handler.popupShow();  
                    
                    track_event({
						category:'general',
						action:'login',
						label:CommInfo.login_typeName+"[fail]",
						value:1
					});	
                }
        }
}

function thirdPartyLoginWinFocus(){
	if(thirdPartyLoginWin != null)
	{
		thirdPartyLoginWin.activate();
		
	}
	return;
	
    var win_close = login_closed(thirdPartyLoginWin);
    if(!win_close){
         thirdPartyLoginWin.focus();
         return true;        	 
    }
    return false;
}

/*
	Get user information.
*/
function get_user_info()
{
    if (parseInt(CommInfo.login_type) != 0)
	{
		body = {"token":CommInfo.token,"login_type":CommInfo.login_type};
	}
	else
	{
		body = {"token":CommInfo.token};
	}

    var data_encode = util.urlencode(body);

    jQuery.ajax({
         url:API.info,
         contentType:"application/json",
         type:"post",
         data:data_encode,
         success:get_user_info_result,
         error:function(){
        	 print_msg("get user info error.");
        	 CommInfo.is_login = false;
             //thirdPartyLoginWin.close();
             //thirdPartyLoginWin = null;
             //main_handler.popupShow();
         }
    });
}

/*
	Callback of get_user_info.
	Params:
		xhr: XMLHttpRequest.
*/
function get_user_info_result(resp)
{
    if(resp.status == 0) 	//connect success
    {	
            //CommInfo.nick_name = resp.data.nick_name;
            CommInfo.user_name = resp.data.user_name;
            if(CommInfo.email == '') {
                CommInfo.email = CommInfo.user_name;
            }
            CommInfo.is_login = true;
            print_msg(CommInfo.nick_name);
            print_msg("login success");
            login_init();
    }
    else
    {
            print_msg("get user info callback error.");
    }
    
    //thirdPartyLoginWin.close();
    //thirdPartyLoginWin = null;
    //main_handler.popupShow();
}

/*
	Dolphin account login.
	Params:
		username:
		password:
		shade_ctrl: handler of shade control
		show_error: handler of error display
		win_close: handler of close login window
*/
function dolphin_login(username,password,shade_ctrl,show_error,close)
{
	//if(CommInfo.logining)
	//{
	//	return;
	//}
	
	//tmp_user_name = username;
	//tmp_password = password;
	
	//////////sonar_close();
	//CommInfo.logining = true;
	
	dolphin_login_shade_handler = shade_ctrl;
	dolphin_login_error_handler = show_error;
	dolphin_loginwin_close = close;
	
	var client_id = util.get_clientid(false);
	var body={'user_name':username,'password':password,'client_id':client_id};
	var data_encode = util.urlencode(body);
	
    CommInfo.user_name = username;
	CommInfo.nick_name = username;
	CommInfo.email = username;
	
	dolphin_xhr = jQuery.ajax({
            url:API.auth,
            contentType:"application/json",
            type:"post",
            data: data_encode,
            success:dolphin_login_result,
            error: function(status){
            	print_msg("dolphin account login failed.");
        		dolphin_login_shade_handler(false);
                dolphin_login_error_handler('Network error, login failed');            		
            }          
        });
}

function dolphin_login_cancel() {
	if(dolphin_xhr) {
		try {
			dolphin_xhr.abort();		
		}
		catch(e) {
			print_msg(e.message);
		}
		dolphin_xhr = null;
	}
}

/*
	Callback of dolphin login.
	Params:
		xhr: XMLHttpRequest.
*/
function dolphin_login_result(resp)
{
        if(resp.status == 0) 	//connect success
        {	
                CommInfo.token = resp.data.token;
                CommInfo.login_type = 0;
                CommInfo.is_login = true;
                CommInfo.login_typeName = 'Dolphin';
				CommInfo.region_domain = null;
				CommInfo.region_domain = resp.data.region_domain;
				CommInfo.push_domain = null;
				CommInfo.push_domain = resp.data.push_domain;
                
                //CommInfo.logining = false;
                if(dolphin_loginwin_close != null)
                {
                        dolphin_loginwin_close();
                }	
                login_init(true);
                track_event({
					category:'general',
					action:'login',
					label:"Dolphin [success]",
					value:1
				});	
        }
        else
        {
                //CommInfo.logining = false;
                dolphin_login_shade_handler(false);
                dolphin_login_error_handler('Username or password error!');
                track_event({
					category:'general',
					action:'login',
					label:"Dolphin [fail]",
					value:1
				});	
        }
}				

/*
	User login initialization.This function will clear device list and current open tab list,
	then validate token.
*/
function login_init(first_login)
{
	if(first_login != null && first_login ==true) {
		chrome.tabs.executeScript(null, {code: GEN_INJECT_SCRIPT(INJECT_STATUS['LOGIN'], extLocale['Login Successful']), file: "cs_overlayer.js"});	
	}
	
	//if there's failed logout info, try again.
	logout_failed_retry();
	
	//clear push device list.
	CommInfo.device_list.splice(0,CommInfo.device_list.length);
	//clear cur tab list.
	CommInfo.cur_tab_list.splice(0,CommInfo.cur_tab_list.length);
	
	//save use info to localstorage
	save_user_login_info();

	if(CommInfo.user_id) {
		print_msg("setBelugaCode")
		setBelugaCode(CommInfo.user_id);
	}
	else {
		API_validate_token();
	}
		
	push_init();
}

var logout_num = 0;

function logout()
{
	logout_num = 0;
	var info = {
		token:CommInfo.token,
		dev_id:util.get_clientid(true)
	};
	
	//save user info for failed reconnect to logout.
	localStorage['DolphinBrowserLogout'] = JSON.stringify(info);
	
	logout_api(info);
	logout_clear();
}

function logout_api(info)
{
	var data_encode = util.urlencode({token:info.token, device_id:info.dev_id, self_logout:1});
	logout_num += 1; 
	jQuery.ajax({
        url:API.logout(),
        contentType:"application/json",
        type:"post",
        data: data_encode,
        success: function(msg) {
        	if(msg.status == 0) {
        		delete localStorage['DolphinBrowserLogout'];
				print_msg("logout success.");
        	}
        	else {
				//if server failed, not retry.
        		print_msg("logout failed.");
        	}
        },
        error: function(){
        	print_msg("logout failed.");
        	if(logout_num < 10) {
        		logout_failed_retry();        	
        	}
        }          
    });
}

function logout_failed_retry() {
	var info = localStorage['DolphinBrowserLogout'];
	if (info != null && info!= '') {
		var info_json = JSON.parse(info);
		logout_api(info_json);
	}	
}

/*
	Clear user information.
*/
function logout_clear()
{
	push_close();
	baTrackClose();
	CommInfo.device_list = [];
	removeall_menu();
	tabs_sync_clear();
	destory_mainWin();
	
	CommInfo.is_login=false;
	CommInfo.logining = false;
	CommInfo.sync_first = true;
	//CommInfo.region_domain = null;
	//CommInfo.push_domain = null;
	
	close_setting_page();

    setTimeout(
    	function(){
		    delete localStorage['DolphinBrowserUserLoginInfo'];
		    delete localStorage['DolphinBrowserAfterSid'];
		    delete localStorage['DolphinBrowserAccountChange'];
		    delete localStorage['DolphinBrowserSyncTabs'];
		    delete localStorage['DolphinBrowserBookmark'];
		    delete localStorage['DolphinBrowserTabSyncId'];
		    delete localStorage['DolphinBrowserDevName'];
		    delete localStorage['DolphinBrowserPushShortcuts'];
		    delete localStorage['DolphinBrowserSetting'];
			delete localStorage['DolphinBrowserDevicePushNum'];
    	},
    	500
    );
}

/*
	Open UserInfo Page
*/
function open_userinfo_page(refresh)
{	

	var data = require('sdk/self').data;
	var info_url = data.url('src/info.html');
	var tabs = require('sdk/tabs');
	var info_tab = null;
	
	for each (var tab in tabs)
	{
		if(tab.url == info_url) {
			info_tab = tab;
			break;
		}
	}	
	
	if(info_tab != null) {
		info_tab.activate();		
	}
	else {
		tabs.open(info_url);
	}
}


/*
	When use logout, all setting page of this extension should close together.
*/
function close_setting_page()
{
	var tabs = require("sdk/tabs");
	var info_url = require("sdk/self").data.url("src/info.html");
	for each (var tab in tabs)
	{
		if(tab.url == info_url) {
			tab.close();
		}
	}	
}

/*
	Save push tabs to local storage
	Params:
		tabs: tabs to be saved
*/


/*
	Save user login info to local storage.
	Storage structure:
		{
			"token":"f96b10ecea434292a59fc354777aaf06",
			"user_name":"raytest@gmail.com",
			"nick_name":"raytest",
			"login_type":"10",
			"login_typeName":"Google"
		}
*/
function save_user_login_info()
{
	var info = {
		token: CommInfo.token, 
		user_name:CommInfo.user_name,
		email:CommInfo.email, 
		nick_name:CommInfo.nick_name,
		login_type:CommInfo.login_type,
		login_typeName:CommInfo.login_typeName,
		region_domain:CommInfo.region_domain,
		push_domain:CommInfo.push_domain,
		user_id:CommInfo.user_id
	};
	localStorage['DolphinBrowserUserLoginInfo'] = JSON.stringify(info);
	print_msg("save info success.");
}

/*
	Check user last login status.
*/
function check_login_status(){
	//if not login, then check login save info
	if(!CommInfo.is_login)
	{
		var user_login_info = localStorage['DolphinBrowserUserLoginInfo'];
		if(user_login_info != null && user_login_info != '')
		{
			var login_info = JSON.parse(user_login_info);
			check_last_login(login_info);
			login_init();	
		}
	}
}

/*
	Restore user last saved info.
	Params:
		login_info: json dict type.
*/	
function check_last_login(login_info)
{
	//CommInfo.user_id = login_info.user_id;
	CommInfo.user_name = login_info.user_name;
	CommInfo.nick_name = login_info.nick_name;
	CommInfo.email = login_info.email;
	CommInfo.token = login_info.token;
	CommInfo.login_type = login_info.login_type;
	CommInfo.login_typeName = login_info.login_typeName;
	CommInfo.is_login = true;
	CommInfo.sync_first  =true;
	CommInfo.region_domain = login_info.region_domain;
	CommInfo.push_domain = login_info.push_domain;	
	CommInfo.user_id = login_info.user_id;
}

var chrome = {
	tabs:{
		executeScript: require("../inject_cs").executeScript
	}
};
