exports.reflashPage=reflashPage;
exports.destory_mainWin = destory_mainWin;
exports.destory_loginWin = destory_loginWin;
exports.refreshInfoPage = refreshInfoPage;
exports.refreshDevicename = refreshDevicename;
exports.updateMainPanelConnect = updateMainPanelConnect;

var track_event = require("./track").track_event;
var account = require("./login/account");
var get_command = require("./login/sonnar").checkGeolocationAPI;
var cs_inject = require("./inject_cs");
var util = require("./util");
var get_sonar_cmd = require("./login/sonnar").get_sonar_cmd;
var getFavicon = require("./util").getFavicon;
var init_setting = require("./util").init_setting;
var BookmarkSyncCtrl = require("./bookmarks/control").BookmarkSyncCtrl();
var CommInfo = require("./common").CommInfo();
var context_menu = require("./menu");
var push = require("./push/push");
var baTrackInit = require("./track").baTrackInit;
var print_msg = require("./util").print_msg;
var pushReConnect = push.pushReConnect;
const {Cc,Ci} = require("chrome");
var GetPushDevicesSorted = require("./util").GetPushDevicesSorted;
var login_process = false;
var loginWin = null;
var mainWin = null;
var infoPageMod = null;
var infoPageWorker = null;

function reflashPage(devices, shortcut, type) {
	print_msg("reflash");
	if(mainWin != null) {
		//mainWin.port.emit("message", {type:'updateConnect', data:push.isConnect()});
		mainWin.port.emit("message",{type:'reflashPage', data:{devices:devices, shortcut: shortcut, type:type, connectStatus:push.isConnect()}});
	}
}

function refreshInfoPage() {
	if(infoPageWorker == null) {
		return;
	}
	infoPageWorker.port.emit("message", {type:'shortCutInit', data:{
	    device_list:CommInfo.device_list,
	    device_shortcut:CommInfo.get_device_shortcut()
	}});	
}

function refreshDevicename(name){
	if(infoPageWorker == null) {
		return;
	}
	infoPageWorker.port.emit("message", {type:'refresh_name', data:name});		
}

function destory_mainWin() {
	if(mainWin != null) {
		mainWin.destroy();
		mainWin = null;
	}
}

function destory_loginWin() {
	if(loginWin != null) {
		loginWin.destory();
		loginWin = null;
	}
}

function loginPanel() {
	print_msg("login Panel func");
	loginWin = require("sdk/panel").Panel({
		width:748,
		height:359,
	    contentURL:require("sdk/self").data.url("src/index.html"),                
	    contentScriptFile: [require("sdk/self").data.url("src/js/index.js"), require("sdk/self").data.url("src/js/indexAdaptor.js")]
	});
	
	loginWin.on("show", function(){
		print_msg("Login panel show.");
		loginWin.port.emit("message", {type:'load', data:{}});
	}); 
	
	loginWin.port.on("message", function(message){
	    var type = message.type;
	    var data = message.msg;        
		var func = loginOnMessageHandler[type];
		if( func != null){
	    	func(data);
		}
	});
	
	loginOnMessageHandler = {
	    thirdParty_login: thirdPartyLogin,
	    dolphin_login:dolphinLogin,
	    dolphin_login_cancel:dolphin_login_cancel,
	    get_sonar_cmd: sonarLoginPhrase,
	    display:display,
		hide:hide,
		ga:track_event
	};
	
	function display(info) {
		loginWin.resize(info.width, info.height);
	}
	
	function hide() {
		loginWin.hide();
	} 
	
	function thirdPartyLogin(type){
	    print_msg("account:"+type);
	    hide();
	    account.thirdParty_login(type,{
	    	popupHidden:function(){login_process=true;},
	    	popupShow:function(){login_process=false;}
	    }); 
	}
	
	function dolphinLogin(info){
		print_msg("dolphin login");
		account.dolphin_login(info.username, info.password, dolphinLogin_shade, dolphinLogin_error, dolphinLogin_close);
	}
	
	function dolphin_login_cancel() {
		account.dolphin_login_cancel();
	}
	
	function dolphinLogin_shade() {
		loginWin.port.emit("message", {type:'dolphin_shade', data:{}});
	}
	
	function dolphinLogin_error(msg) {
		loginWin.port.emit("message", {type:'dolphin_fail', data:msg});
	}
	
	function dolphinLogin_close() {
		if(loginWin != null){
			loginWin.destroy();
			loginWin = null;			
		}
	}
	
	function sonarLoginPhrase(info){
		get_sonar_cmd(show_word,show_error,win_close,info);
	}
	
	function show_word(phrase, option) {
		loginWin.port.emit("message", {type:'sonar_success', data:[phrase,option]});
	}
	
	function show_error(){
		loginWin.port.emit("message", {type:'sonar_fail'});
	}
	
	function win_close(){
		print_msg("sonar login win close.");
		if(loginWin != null) {
			loginWin.destroy();
			loginWin = null;			
		}
	}
}

function updateMainPanelConnect(connectStatus)
{
	if(mainWin == null)
		return;
		
	mainWin.port.emit("message", {type:'updateConnect', data:connectStatus});	
}

function mainPanel() {
	var firstLoading = true;
	mainWin = require("sdk/panel").Panel({
		width: 350,
		height: 254,
	    contentURL:require("sdk/self").data.url("src/mainPane.html"),
	    contentScriptFile: [require("sdk/self").data.url("src/js/index.js"), require("sdk/self").data.url("src/js/indexAdaptor.js")]
	});
	//print_msg("main Win create");
	mainWin.on("show", function(){
		//print_msg("Main panel show.");
		var tabs = CommInfo.tab_sync_list_sorted();
		if(firstLoading)
		{
			firstLoading = false;
			mainWin.port.emit("message", {type:'load', data:{
				nick_name:CommInfo.nick_name,
				device_list:GetPushDevicesSorted(),
				device_shortcut:CommInfo.get_device_shortcut(),
				tab_sync_list_sorted:tabs,
				is_connect:push.isConnect(),
				setting:CommInfo.get_setting(),
				favicons:getFavicons(tabs)
			}});		
		}
	}); 
	
	mainWin.port.on("message", function(message){
		var type = message.type;
		var data = message.msg;
		//print_msg("main panel recv message:"+type);
		var func = mainPanelOnMessageHandler[type];
		if( func != null){
	    	func(data);
		}
	});
	
	mainPanelOnMessageHandler = {
		current_tab: currentTab,
		pushSend: pushSend,
		open_userinfo_page: open_userinfo_page,
	    display:display,
		hide:hide,
		reConnect:pushReConnect
	};
	
	function getFavicons(tabs) {
		var favicons = {};
		for(var idx in tabs) {
			var urls = tabs[idx].data.data;
			for(var id in urls) {
				if(urls[id].url == null) {
					continue;
				}
				if(favicons.hasOwnProperty(urls[id].url)) {
					continue;
				}
				else{
					try {
						var icon_url = getFavicon(urls[id].url);
						favicons[urls[id].url]  = icon_url;					 
					}
					catch(e) {
						favicons[urls[id].url] = null;
					}
				}
			}
		}
		return favicons;
	}
	
	function display(info) {
		//mainWin.hide();
		mainWin.resize(info.width, info.height);
		//mainWin.show(mainWin.tb);
	}
	
	function hide() {
		mainWin.hide();
	} 
	
	function currentTab(){
		var tabs = require("sdk/tabs");
		mainWin.port.emit("message",{type:'current_tab', data:[{
			title:tabs.activeTab.title,
			url:tabs.activeTab.url
		}]});
	}
	
	function pushSend(id){
		print_msg("send page in mainpanel");
		push.pushSend(id, null);
	}
	
	function open_userinfo_page(){
		print_msg("open userinfo page");
		account.open_userinfo_page();
	}
}

function infoPage(){
	var pageMod = require("sdk/page-mod");
	var info_url = require("sdk/self").data.url('src/info.html');
	var infoWorker = null;
	var infoPageMod = pageMod.PageMod({
		include: info_url,
		contentScriptFile: [require("sdk/self").data.url("src/js/index.js"), require("sdk/self").data.url("src/js/indexAdaptor.js")],
		onAttach: function(worker) {
			print_msg("info contentscript attach.");
			worker.port.on("message", function(message){
				var type = message.type;
				var data = message.msg;
				var func = infoOnMessageHandler[type];
				if(func != null) {
					func(data);
				}
			});
			worker.port.emit("message", {type:'load', data:{
			    nick_name:CommInfo.nick_name,
			    email:CommInfo.email,
			    device_list:CommInfo.device_list,
			    device_shortcut:CommInfo.get_device_shortcut(),
			    user_name:CommInfo.user_name,
			    token:CommInfo.token,
			    login_typeName:CommInfo.login_typeName,
			    devicename:util.get_devicename(),
				setting:CommInfo.get_setting() 
			}});
			
			worker.on('detach', function () {
      			//detachWorker(this, workers);
				infoPageWorker = null;
    		});
			
			infoPageWorker = worker;
	 	}
	});
	
	var infoOnMessageHandler = {
		devRename:dev_rename,
		save_setting:save_setting,
		save_dev_shortcut:save_dev_shortcut,
		logout:logout,
		ga:track_event
	};
	
	function dev_rename(info) {
		print_msg("dev rename");
		push.dev_rename(info.dev_id, info.name, info.type);
	}
	
	function save_setting(info) {
		print_msg("save setting");
		CommInfo.save_setting(info);
	}
	
	function save_dev_shortcut(info) {
		print_msg("save shortcut");
		CommInfo.save_device_shortcut(info);
	}
	
	function logout() {
		print_msg("logout");
		if(mainWin != null){
			mainWin.destroy();
			mainWin = null;			
		}
		infoPageWorker = null;
		account.logout();
	}
	
	return infoPageMod;
}

exports.main = function (options, callbacks) {
	baTrackInit();
	init_setting();
	BookmarkSyncCtrl.init();
	//////////////////////////////////////////////////////////////////////
	// ContentScript inject.
	//////////////////////////////////////////////////////////////////////
    
	cs_inject.inject_init();
    infoPage();
    account.check_login_status();
    
	//////////////////////////////////////////////////////////////////////
	// Addon icon button click handler.
	//////////////////////////////////////////////////////////////////////
   
    var tbb = require("toolbarbutton").ToolbarButton({
        id: require("sdk/self").id,
        label: "DolphinConnect",
        image: require("sdk/self").data.url("src/images/logo16.png"),
        onCommand: function(tb) {
        	if(CommInfo.is_login == false){
                if(login_process == false){
                	if(loginWin != null){
                		loginWin.destroy();
                		loginWin = null;
                	}
            	    loginPanel();	
                	loginWin.show(tb);
                }
                else{
                	account.thirdPartyLoginWinFocus();  
                }        		
        	}
        	else{
        		if(mainWin != null) {
        			mainWin.destroy();
        			mainWin = null;
        		}
        		mainPanel();
        		mainWin.show(tb);
        		mainWin.tb = tb;
        	}
        }        
    });

    tbb.moveTo({
         toolbarID: "nav-bar",
         forceMove: false         
    });
}

exports.onUnload = function (reason) {
	print_msg(reason)
	var localStorage = require("sdk/simple-storage").storage;
	
	if(reason != 'shutdown') {
		delete localStorage['DolphinBrowserUserLoginInfo'];
		delete localStorage['DolphinBrowserAfterSid'];
		delete localStorage['DolphinBrowserAccountChange'];
		delete localStorage['DolphinBrowserSyncTabs'];
		delete localStorage['DolphinBrowserBookmark'];
		delete localStorage['DolphinBrowserTabSyncId'];
		delete localStorage['DolphinBrowserDevName'];
		delete localStorage['DolphinBrowserPushShortcuts'];
		delete localStorage['DolphinBrowserSetting'];
		print_msg("uninstall finish.");	
	}
};
