exports.track_error = track_error;
exports.track_event = track_event;
exports.track_close = track_close;
exports.baTrackInit = baTrackInit;
exports.baTrackClose = baTrackClose;
exports.setBelugaCode = setBelugaCode;

var pageWorkers = require("sdk/page-worker");
var print_msg = require("./util").print_msg;
function track_close() {
	print_msg("track close");
}
var _ba = null;

/* 
	@para {error object}err
	@return null
*/
function track_error(err){
	baTrackErr(err);
	return ;
}

/*
	Params:
		-config:
	Example:
		{
			category:'testCategory',
			action:'testAction',
			label:'testLabel',
			value:10
		}
*/
function track_event(config, opt) {
	try {
		if(opt == null) {
			ga_track_event(config);
			
			if(_ba) {
				config.category = 'firefox_en';
				baTrack(config);
				if(config.action=='TabSync') {
					config.category = 'sync';
					config.action = 'tabs';
					config.label = '';
					baTrack(config);
				}
				else if(config.action =='BookmarkSync') {
					config.category = 'sync';
					config.action = 'bookmarks';
					config.label = '';				
					baTrack(config);
				}				
			}
		}
		else 
		{	
			if(_ba) {
				baTrack(config);		
			}			
		}
	}
	catch(e) {
		print_msg("track event error.");
		print_msg(e);
	}
}

function ga_track_event(config) {
	//var category = config.category;
	//var action = config.action;
	//var label = config.label;
	//var value = config.value;
	//
	//try {
	//	var gaUrl = gaTrackUrl('UA-35178856-1','sen.dolphin-browser.com', category, action, label, value);
	//	
	//	var XMLHttpRequest = require("sdk/net/xhr").XMLHttpRequest;
	//    var xhr = new XMLHttpRequest();
	//   	xhr.open('get', gaUrl, true);
	//   	xhr.send();
	//}
	//catch(e) {
	//	print_msg("ga send failed.");
	//	print_msg(e);
	//}
   	
}

/*
	Googe Analytic url generator.
*/
function gaTrackUrl(trackid, domain, category, action, label, value) {
	  //category = 'firefox_en';
	  //var i=1000000000, utmn=rand(i,9999999999), cookie=rand(10000000,99999999), random=rand(i,2147483647), today=(new Date()).getTime();
	  //var ga_url = 'http://www.google-analytics.com/__utm.gif?utmwv=5.3.8&utmn='
	  //    +utmn+'&utms=5&utmsr=-&utmsc=-&utmul=-&utmje=0&utmfl=-&utmdt=-&utmt=event&utme=5'
	  //    +'('
	  //    +category+'*'+action+'*'+label+')('+value+')&utmcs=UTF-8&utmhn='
	  //    +domain+'&utmr=-'+'&utmp=%2F_generated_background_page.html&utmac='
	  //    +trackid+'&utmcc=__utma%3D'
	  //    +cookie+'.'+random+'.'+today+'.'+today+'.'
	  //    +today+'.2%3B%2B__utmb%3D'
	  //    +cookie+'%3B%2B__utmc%3D'
	  //    +cookie+'%3B%2B__utmz%3D'
	  //    +cookie+'.'+today
	  //    +'.1.1.utmcsr%3D(direct)|utmccn%3D(direct)|utmcmd%3D(none)%3B&utmu=4~';
		
	//return ga_url;  
}

function rand(min, max) {
	return min + Math.floor(Math.random() * (max - min));
}
 
function setBelugaCode(user_id) {
	if(_ba) {
		try {
			_ba.port.emit("message", {type:"setAppInfo", data:user_id});
		}
		catch(e) {
			print_msg(e);
		}
	} 	
}

function baTrackErr(err){
	if(_ba){
		try{
			_ba.port.emit("message", {type:'errTrack', data:err});
		}catch(e){
			print_msg(e);
		}
	}
}

function baTrack(config) {
	if(_ba) {
		try {
			print_msg("baTrack call..");
			_ba.port.emit("message", {type:'track',data:config});
		}
		catch(e) {
			print_msg(e);
		}
	} 	
}

function baTrackInit() {
	var data = require("sdk/self").data;
	_ba  = pageWorkers.Page({
	     contentUrl: data.url("src/ba_track.html"),
	     contentScriptFile: [
		 	data.url("src/ba.js"),
	        data.url("src/cs_ba.js")
	     ]    
	});   	
}

function baTrackClose() {
	if(_ba) {
		try{
			_ba.destroy();
		}
		catch(e) {
			print_msg(e);
		}
		_ba = null;
	}
}
