exports.jQuery = function(){ return jQueryProxy;};
exports.urlencode = urlencode;
exports.get_os_type = get_os_type;
exports.get_clientid = get_clientid;
exports.getQueryStringRegExp = getQueryStringRegExp;
exports.get_utc= get_utc;
exports.get_devicename = get_devicename;
exports.gen_devicename = gen_devicename;
exports.save_devicename = save_devicename;
exports.showNotification = showNotification;
exports.getFavicon = getFavicon;
exports.init_setting = init_setting;
exports.createNotification = createNotification;
exports.getByteLength = getByteLength;
exports.print_msg = print_msg;
exports.GetPushDevicesSorted = GetPushDevicesSorted;
exports.debug = function(){return debug;};
var localStorage = require("sdk/simple-storage").storage;
var CommInfo = require("./common").CommInfo();
const {Cc,Ci} = require('chrome');

/*
 * This function is very simple.I will make it better later, but not now.
 */
var jQueryProxy = {
    ajax : function(config) {
       var XMLHttpRequest = require("sdk/net/xhr").XMLHttpRequest;
       var xhr = new XMLHttpRequest(); 
       xhr.onreadystatechange = function() {
           //print_msg(xhr.readyState);
           if(xhr.readyState == 4) {
               if(xhr.status === 200 && config.success) {
                    config.success(JSON.parse(xhr.responseText));
               }
               else if(config.error){
                    print_msg(xhr.status);
                    config.error();
               }
           }    
       };      
       
       xhr.open(config.type, config.url, true);
       if (config.headers) {
           for (var header in config.headers) {
               if (config.headers.hasOwnProperty(header)) {
               		if(header == 'ClientVersion') {
      					config.headers[header] = CommInfo.client_version;
      				}
                   	xhr.setRequestHeader(header, config.headers[header]);
               }
           }
        } 
        xhr.setRequestHeader("Content-Type", config.contentType);
   		xhr.timeout = 15*1000;
   		xhr.ontimeout = function(){
   			if(config.error) {
   				config.error("timeout");
   			}
        }   
        xhr.send(config.data);
        return xhr;
    }  
};

/*
 *      Encode params, transform json dict to key=value joined with '&'
 *              Param:
 *                              params: json dict
 *                              */
function urlencode(params)
{
        if(typeof params == 'object')
        {
                var elements = new Array();

                for(var param in params)
                {
                        if (typeof params[param] == 'object')
                        {
                                elements.push(param+"="+encodeURIComponent(JSON.stringify(params[param])));
                        }
                        else
                        {
                                elements.push(param+"="+encodeURIComponent(params[param]));
                        }
                }
                return elements.join('&');
        }
        else {
                return encodeURIComponent(params);
        }
        //return encodeURIComponent(JSON.stringify(params));
}
function get_os_type()
{
        //var dev_name = get_devicename();
        //var agt = window.navigator.userAgent.toLowerCase(); 
        var devices = {'windows':3,'mac':4,'linux':5,'ubuntu':5};
        const {Cc,Ci} = require("chrome");
        var httpHandler = Cc["@mozilla.org/network/protocol;1?name=http"].getService(Ci.nsIHttpProtocolHandler);
        var agt = httpHandler.userAgent;

        var name = 'PC';
        
        for(var dev in devices)
        {
             if(agt.indexOf(dev) != -1)
             {
                  return devices[dev];
             
             }
        }
        
        return devices['windows'];
}

function get_clientid(flag)
{
        var _uuid = localStorage['DolphinBrowserClientId'];
        if(_uuid == null)
        {
            _uuid = require('sdk/util/uuid').uuid();
            var b = ""+_uuid;
            _uuid = b.substring(1,b.length-2);

            print_msg(_uuid);
            //_uuid = uuid();
            localStorage['DolphinBrowserClientId'] = _uuid;
        }
        if(flag == true)
        {
                return _uuid + ":" + CommInfo.user_name;
        }
        else
        {
                return _uuid;
        }
}



function getQueryStringRegExp(url,name)
{
    var reg = new RegExp("(^|\\?|&)"+ name +"=([^&]*)(\\s|&|$)", "i"); 
    var url_decode = decodeURIComponent(url);  
    
    //check whether ended with url hash.
    var location_hash = url_decode.indexOf("#");
    if(location_hash > 0) {
    	url_decode = url_decode.substring(0,location_hash);
    }
    
    if (reg.test(url_decode)) 
    {
            return unescape(RegExp.$2.replace(/\+/g, " ")); 
    }
    else
    {
            return "";
    }
};


function get_utc()
{
        var now = new Date;
        //var utc_timestamp = Date.UTC(now.getFullYear(),now.getMonth(), now.getDate(), now.getHours(), now.getMinutes(), now.getSeconds(), now.getMilliseconds());
        var utc_timestamp = now.getTime();
        return utc_timestamp;
        //return parseInt(utc_timestamp/1000);
}

/*
	Get string byte length.
*/
function getByteLength(str){
	if(str == null){
		return 0;	
	}
	return str.replace(/[^\x00-\xff]/g,"**").length;
}

function get_devicename() {
	var dev_name = localStorage['DolphinBrowserDevName'];
	if(dev_name == null || dev_name == '') {
		return  '';
	}
	else {
		dev_name = JSON.parse(dev_name);
		if(dev_name[CommInfo.user_name] == null) {
			return '';			
		}
		else{
			return dev_name[CommInfo.user_name];
		}		
	}
}

function save_devicename(name) {
	var dev_name = localStorage['DolphinBrowserDevName'];
	if(!dev_name || dev_name.length == 0) {
		dev_name = {};
	}
	else{
		dev_name = JSON.parse(dev_name);
	}	
	
	dev_name[CommInfo.user_name] = name;
	localStorage['DolphinBrowserDevName'] = JSON.stringify(dev_name);
}

/*
Get device name,one of ['PC','ubuntu','mac'] with prefix in 
['Silver','Yellow', 'Gold', 'Red', 'Green', 'Blue', 'Purple', 'White', 'Black', 'Brown'] or user defined name;
*/
function gen_devicename()
{	
	//using useragent to decide 3 device type.
	var devices = {'windows':'PC','mac':'Mac','linux':'Ubuntu','ubuntu':'Ubuntu'};
	const {Cc,Ci} = require("chrome");
	var httpHandler = Cc["@mozilla.org/network/protocol;1?name=http"].getService(Ci.nsIHttpProtocolHandler);
	var userAgent = httpHandler.userAgent;
	var agt = userAgent.toLowerCase(); 
	var name = 'PC';
	
	for(var dev in devices)
	{
		if(agt.indexOf(dev) != -1)
		{
			name = devices[dev];
			break;
		}
	}
	
	var dev_prefix = ['Silver','Yellow', 'Gold', 'Red', 'Green', 'Blue', 'Purple', 'White', 'Black', 'Brown'];
	var buildin_dev_name = {};
	for(var idx in dev_prefix)
	{
		buildin_dev_name[dev_prefix[idx]+" "+name] = 0;
	}	
	buildin_dev_name[name] = 0;
	print_msg(JSON.stringify(buildin_dev_name));
	
	var all_dev = CommInfo.device_list;
	print_msg(JSON.stringify(all_dev));
	if(all_dev == null || all_dev.length == 0){
		name = ''+name;
	}
	else{
		for(var id in all_dev) {
			if(buildin_dev_name.hasOwnProperty(all_dev[id].deviceName)){
				delete buildin_dev_name[all_dev[id].deviceName];
			}
		}
		
		var i=0;
		if(buildin_dev_name.hasOwnProperty(name)) {
			name = name;
		}
		else {
			for(i=0;i < dev_prefix.length; i++){
				if(buildin_dev_name.hasOwnProperty(dev_prefix[i]+" "+name)){
					name=dev_prefix[i]+" "+name;
					break;
				}
			}
		}	
		save_devicename(name);
	}
	return name;
}

function showNotification(title, message) {
	/*
	if((title == 'Sync Complete' || title == 'Sync Failed') && CommInfo.sync_first)
	{
		CommInfo.sync_first = false;
		createNotification(title,'');
	}
	*/	
}

function createNotification(title,message)
{
	var notifications = require("sdk/notifications");
	notifications.notify({
	    title: title,
	    text: message,
	    iconURL:require("sdk/self").data.url("src/images/logo32.png")
	});
}

/*
First install initialize.Tab sync is enabled by default.
*/
function init_setting()
{
	var client_id = localStorage['DolphinBrowserClientId'];
	if(client_id == null)
	{
		 get_clientid(false);
		//if it's first installed, then show help page.
		//chrome.tabs.create({url:"http://www.dolphin-browser.com/help/extension.html"});
		 require("sdk/tabs").open({url:"http://www.dolphin-browser.com/help/extension.html"});
	}
}

var faviconService = Cc["@mozilla.org/browser/favicon-service;1"].getService(Ci.nsIFaviconService);
var ioservice = Cc["@mozilla.org/network/io-service;1"].getService(Ci.nsIIOService);

/*
 * Reference:
 * 	[1] https://developer.mozilla.org/en-US/docs/XPCOM_Interface_Reference/nsIFaviconService#getFaviconImageForPage%28%29
 * 	[2] https://developer.mozilla.org/en-US/docs/XPCOM_Interface_Reference/nsIURI
 */
function getFavicon(url) {
	//print_msg(url);
	var pageURI = ioservice.newURI(url, null, null);
	var faviconURI = faviconService.getFaviconImageForPage(pageURI);	
	var url  = faviconURI.spec;
	if(url.indexOf("moz-anno:favicon:") == 0) {
		url = url.substring(17);
	}
	return url;
}

debug = false;
function print_msg(msg)
{
	if(debug)
	{
		console.log(msg);	
	}
}

function GetPushDevicesSorted()
{
	deviceList=CommInfo.device_list;
	onlineDevs=[];
	offlineDevs=[];
	devPushNum=localStorage['DolphinBrowserDevicePushNum'];
	if(devPushNum)
	{
		devPushNumJson = JSON.parse(devPushNum);	
	}
	else
	{
		devPushNumJson ={};
	}
	for(idx in deviceList)
	{
		if(deviceList[idx].state == 1)
		{
			onlineDevs.push(deviceList[idx]);
		}
		else
		{
			offlineDevs.push(deviceList[idx]);
		}
		if(devPushNumJson[deviceList[idx].did])
		{
			deviceList[idx].pushNum=devPushNumJson[deviceList[idx].did];		
		}
		else
		{
			deviceList[idx].pushNum=0;
		}
	}
	
	if(onlineDevs.length > 1)
	{
		onlineDevs.sort(function(a,b){return b.pushNum-a.pushNum;});
	}
	
	if(offlineDevs.length > 1)
	{
		offlineDevs.sort(function(a,b){return b.pushNum-a.pushNum;});
	}
	
	print_msg(JSON.stringify(onlineDevs.concat(offlineDevs)));
	return onlineDevs.concat(offlineDevs);
}
